#ifndef D11_CMDS
#define D11_CMDS
extern void SetMode(unsigned char D11_MDATA, unsigned char D11_CLKDIV);
extern void SetAddress(unsigned char NewAddr);
extern void DisOtherAddress(void);
extern void SetEndptEnable(unsigned char Enable_data);
extern void UpdateIntReg(void);
extern void ReadBuffer(void);
extern void WriteBuffer(void);
extern void Ack_SETUP(void);
extern void SendResume(void);
extern unsigned char SelectEndpoint(unsigned char ENDPT);
extern unsigned char ReadEndptStatus(unsigned char ENDPT);
extern void SetEndptStatus(unsigned char ENDPT, unsigned char ENDPTDATA);
extern void ClearBuffer(void);
extern void ValidateBuffer(void);
extern void SendZeroPacket(unsigned char ENDPT);
extern unsigned char ReadEPStall(unsigned char ENDPT);
extern void Port1_Power(void);


extern unsigned char ENDPT_INT;
#define CTRL_ENDPT_OUT 0x04 // bit 2
#define CTRL_ENDPT_IN  0x08 // bit 3
#define ENDPT1_IN      0x10 // bit 4
#define ENDPT1_OUT     0x20 // bit 5
#define ENDPT2_OUT     0x40 // bit 6
#define ENDPT2_IN      0x80 // bit 7

extern unsigned char OTHER_INT;
#define ENDPT3_OUT     0x01 // bit 1
#define ENDPT3_IN      0x02 // bit 2
#define BUS_RESET      0x40 // bit 6
extern unsigned char DBUFFER[9];

#define CTRL_OUT 2 //Endpoint Index
#define CTRL_IN  3  //Endpoint Index
#define ENDPOINT1_OUT 5 //Endpoint Index
#define ENDPOINT1_IN  4 //Endpoint Index
#define ENDPOINT2_OUT 6 //Endpoint Index
#define ENDPOINT2_IN  7 //Endpoint Index
#define ENDPOINT3_OUT 8 //Endpoint Index
#define ENDPOINT3_IN  9 //Endpoint Index



#endif


